<?php

/**
 * Class ExtendedModuleConfig extends Module_Config
 *
 * @see Module_Config
 */
class ExtendedModuleConfig extends ExtendedModuleConfig_parent
{
    /**
     * Saves shop configuration variables
     */
    public function saveConfVars()
    {
        $oConfig = $this->getConfig();

        $this->resetContentCache();

        $sModuleName = $sModuleId = $this->_sModuleId = $this->getEditObjectId();
        $sShopId = $oConfig->getShopId();

        $sModuleId = $this->_getModuleForConfigVars();

        foreach ($this->_aConfParams as $sType => $sParam) {
            $aConfVars = $oConfig->getRequestParameter($sParam);
            if (is_array($aConfVars)) {
                foreach ($aConfVars as $sName => $sValue) {
                    if ($sModuleName === 'findologic_module') {
                        if (preg_match('/^[A-Z0-9]{32}$/', $sValue) || empty($sValue)) {
                            $sDbType = $this->_getDbConfigTypeName($sType);
                            $oConfig->saveShopConfVar(
                                $sDbType,
                                $sName,
                                $this->_serializeConfVar($sDbType, $sName, $sValue),
                                $sShopId,
                                $sModuleId
                            );
                        } else {
                            return false;
                        }
                    }
                }
            }
        }
    }

    /**
     * Convert metadata type to DB type.
     *
     * @param string $sType Metadata type.
     *
     * @return string
     */
    private function _getDbConfigTypeName($sType)
    {
        $sDbType = $sType;
        if ($sType === 'password') {
            $sDbType = 'str';
        }

        return $sDbType;
    }

}

